package org.gcube.portlets.user.workspace.client.event;

import org.gcube.portlets.user.workspace.client.model.FileGridModel;
import org.gcube.portlets.user.workspace.client.model.FileModel;
import org.gcube.portlets.user.workspace.client.view.dialog.DialogPermission;

import com.google.gwt.event.shared.GwtEvent;

/**
 * 
 * @author Francesco Mangiacrapa francesco.mangiacrapa@isti.cnr.it
 *
 */
public class SettingPermissionEvent extends GwtEvent<SettingPermissionEventHandler> {
  public static Type<SettingPermissionEventHandler> TYPE = new Type<SettingPermissionEventHandler>();

  private FileModel targetFile = null;

  private DialogPermission dialogPermission;

  
	public SettingPermissionEvent(FileModel target, DialogPermission dialog) {
		this.targetFile = (FileGridModel) target;
		this.dialogPermission = dialog;
	}

	@Override
	public Type<SettingPermissionEventHandler> getAssociatedType() {
		return TYPE;
	}
	
	@Override
	protected void dispatch(SettingPermissionEventHandler handler) {
		handler.onPermissionSetting(this);
		
	}

	public FileModel getSourceFile() {
		return targetFile;
	}

	public DialogPermission getDialogPermission() {
		return dialogPermission;
	}

	public void setDialogPermission(DialogPermission dialogPermission) {
		this.dialogPermission = dialogPermission;
	}
}